//===========================================================================
//
// Player
//
//===========================================================================
class RatchetPlayer : PlayerPawn Replaces DoomPlayer
{
	int doublestop;
	int doublejumpweapon;
	Default
	{
		Speed 0.6;
		Health 100;
		Radius 16;
		Height 46;
		CameraHeight 46;
		Mass 100;
		PainChance 255;
		DeathSound "rchtdeth";
		Player.JumpZ 8;
		Player.ViewBob 0.4;
		Player.DisplayName "Ratchet";
		Player.CrouchSprite "RCHT";
		Player.StartItem "Wrench";
		Player.StartItem "PDA";
		Player.StartItem "WeaponOwnerToken", 0;
		Player.StartItem "AmmoPickup", 1;
		Player.WeaponSlot 1, "PDA", "Wrench";
		Player.WeaponSlot 2, "HeavyLancer";
		Player.WeaponSlot 3, "BlitzCannon";
		Player.WeaponSlot 4, "MegaTurretGlove";
		Player.WeaponSlot 5, "MegaRocketCannon";
		Player.WeaponSlot 6, "PlasmaCoil";
		Player.WeaponSlot 7, "";
		Player.WeaponSlot 8, "RYNO2";
		Player.WeaponSlot 9, "";
		Player.WeaponSlot 0, "";
	}

	States
	{
	//Standing still, running, and falling states.
	Spawn:
		TNT1 A 0;
		TNT1 A 0
		{	
			A_StopSound(8);
			ACS_Execute(2000);
			ACS_Execute(1);
			ACS_Execute(101);
			ACS_Execute(50);
			ACS_Execute(52);
		}
		TNT1 A 0 A_CheckFloor("OnGround");
		RCHT A 1
		{
			doublejumpweapon++;
		}
		RCHT E 0 A_JumpIf(doublejumpweapon >= 10, "Falling");
		loop;
	See:
		TNT1 A 0 
		{	
			ACS_Execute(1);
			ACS_Execute(50);
			ACS_Execute(52);
			A_StopSound(8);
		}
		TNT1 A 0 A_CheckFloor("SeeOnGround");
		TNT1 A 0 A_StopSound(14);
		RCHT A 1 
		{
			doublejumpweapon++;
		}
		RCHT E 0 A_JumpIf(doublejumpweapon >= 10, "Falling");
		loop;
	OnGround:
		RCHT A 1
		{
			A_StopSound(8);
			doublejumpweapon = 0;
			doublestop = 1;
			ACS_Execute(1);
			ACS_Execute(50);
			ACS_Execute(52);
		}
		Goto Spawn;
	SeeOnGround: 
		RCHT A 1 
		{
			A_StopSound(8);
			A_StartSound("STEP", 14, CHANF_NOSTOP, 1);
			doublejumpweapon = 0;
			doublestop = 1;
			ACS_Execute(1);
			ACS_Execute(50);
			ACS_Execute(52);
			if(random(1, 3) == 1)
			{
				A_StartSound("JANGLER", 15, CHANF_NOSTOP, 0.3);
			}
		}
		Goto Spawn;
	Falling:
		RCHT E 0 A_JumpIf(doublestop == 0, "Spawn"); //Checks if the players has double jumped yet.
		RCHT E 0 A_CheckFloor("OnGround");
		RCHT E 1
		{
			A_StopSound(14);
			ACS_Execute(100);
			ACS_Execute(1);
			ACS_Execute(50);
			ACS_Execute(52);
		}
		loop;
		
		//Charge boots states.
	ChargeBoots1stPress:
		RCHT AAAAAA 1 ACS_Execute(102);
		RCHT A 0
		{
			ACS_Execute(50);
			ACS_Execute(52);
			ACS_Execute(1);
		}
		goto Spawn;
	ChargeBoots2ndPress: //Waits for player to press crouch key again within 6 tics.
		RCHT AAAAAA 1 ACS_Execute(103);
		RCHT A 0 
		{
			ACS_Execute(50);
			ACS_Execute(52);
			ACS_Execute(1);
		}
		goto Spawn; 
	ChargeBootsBlastOff:
		RCHT A 0 A_StartSound("CHARGEBT", 8, CHANF_LOOP|CHANF_NOSTOP, 1, ATTN_NORM, 1);
		//RCHT A 0 A_JumpIf(ACS_ExecuteWithResult(105) == 1, "Spawn");
		TNT1 A 0
		{
			ACS_Execute(1);
			ACS_Execute(50);
			ACS_Execute(52);
			A_SpawnItemEx("ChargeBootLightActor", 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
			A_SpawnParticle("#4287f5", SPF_FULLBRIGHT|SPF_RELATIVE, 56, 3, frandom(-5, 5), random(-20, -15), random(-2, 2), 0, 23, 0, frandom(0.1, 2), -0.42, 0);
			A_SpawnParticle("#619eff", SPF_FULLBRIGHT|SPF_RELATIVE, 58, 5, frandom(-5, 5), random(-20, -15), random(-2, 2), 0, 26, 0, frandom(0.1, 2), -0.38, 0);
			A_SpawnParticle("#2478ff", SPF_FULLBRIGHT|SPF_RELATIVE, 61, 4, frandom(-5, 5), random(-20, -15), random(-2, 2), 0, 24, 0, frandom(0.1, 2), -0.4, 0);
			A_SpawnParticle("#619eff", SPF_FULLBRIGHT|SPF_RELATIVE, 55, 5, frandom(-5, 5), random(-20, -15), random(-2, 2), 0, 20, 0, frandom(0.1, 2), -0.37, 0);
			A_SpawnParticle("#2478ff", SPF_FULLBRIGHT|SPF_RELATIVE, 59, 4, frandom(-5, 5), random(-20, -15), random(-2, 2), 0, 20, 0, frandom(0.1, 2), -0.36, 0);
			A_SpawnParticle("#619eff", SPF_FULLBRIGHT|SPF_RELATIVE, 79, 5, frandom(-5, 5), random(-20, -15), random(-2, 2), 0, 15, 0, frandom(0.1, 2), -0.1, 0);
			A_SpawnParticle("#2478ff", SPF_FULLBRIGHT|SPF_RELATIVE, 83, 4, frandom(-5, 5), random(-20, -15), random(-2, 2), 0, 16, 0, frandom(0.1, 2), -0.1, 0);
		}
		RCHT AAAAAA 1 ACS_Execute(103);
		goto Spawn;
		
		//Double jump state.
	DoubleJumpFinish:
		RCHT E 0 //Disallows another double jump, variable resets upon landing.
		{
			doublestop = 0;
			ACS_Execute(50);
			ACS_Execute(52);
			ACS_Execute(1);
		}
		RCHT E 1 A_CheckFloor("Spawn");
		loop;
		
		//Combat states.
	Missile:
		RCHT A 0
		{
			ACS_Execute(50);
			ACS_Execute(52);
			ACS_Execute(1);
		}
		RCHT A 0 A_JumpIf(doublestop == 0, "Spawn");
		RCHT A 1
		{
			doublejumpweapon++;
		}
		Goto Spawn;
	Melee:
		RCHT A 0;
		Goto Missile;
	Pain:
		RCHT E 0
		{
			A_StartSound("RCHTHURT", 67, CHANF_NOSTOP, 1, ATTN_NORM, 1);
			ACS_Execute(38);
			ACS_Execute(1);
		}
		Goto Spawn;
	Death:
		TNT1 A 0;
		RCHT A 1;
		RCHT A 9 ACS_Execute(51);
		RCHT A 10 A_Scream;
		RCHT A 10 A_NoBlocking;
		RCHT AAA 10;
		RCHT A 0
		{
			ACS_Execute(1);
			ACS_Execute(2);
		}
		RCHT A -1;
		Stop;
	XDeath:
		TNT1 A 0;
		RCHT A 1;
		RCHT A 4 ACS_Execute(51);
		RCHT A 5;
		RCHT A 5 A_NoBlocking;
		RCHT AAAAA 5;
		RCHT A 0
		{
			ACS_Execute(1);
			ACS_Execute(2);
		}
		RCHT A -1;
		Stop;
	}
	/*
	override void OnDestroy()
	{
		if(source == 0)
		{
			A_Print("Unknown");
		}
		else
		{
			A_Print("Known");
		}
	}
	*/
}